
/* cift7-c.c -- CIF test 7, C part */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>

#include "cifccsp.h"

void my_bsyscall (char *string)
{
	struct timeval tv = {1, 500000};

	fprintf (stderr, "the message was [%s]\n", string);
	select (0, NULL, NULL, NULL, &tv);
	fprintf (stderr, "the message was [%s]\n", string);

	return;
}
	

void out_string (char *str, Channel *out)
{
	unsigned char *ch = (unsigned char *)str;

	while (*ch != '\0') {
		/* ChanOut (out, ch, 1); */
		ChanOutChar (out, *ch);
		ch++;
	}
	return;
}

void proc_p1 (Process *me)
{
	BLOCKING_CALLN (my_bsyscall, "wibble!");
}

void proc_p2 (Process *me, Channel *out)
{
	Time t;
	int i;
	char *strs[] = {"bing", "bang", "bosh", NULL};

	for (i=0; strs[i]; i++) {
		out_string ("** ", out);
		out_string (strs[i], out);
		out_string ("\n", out);

		ProcTime (&t);
		ProcTimeAfter (ProcTimePlus (t, 800000));
	}

	return;
}


void my_process (Process *me, Channel *kroc_err)
{
	Process *p1, *p2;

	p1 = ProcAlloc (proc_p1, 4096, 0, NULL);
	p2 = ProcAlloc (proc_p2, 4096, 1, kroc_err);

	ProcPar (p1, p2, NULL);

	ProcAllocClean (p1);
	ProcAllocClean (p2);

	return;
}


/* allocates process and returns address to occam world */
void real_cift7_init (int *raddr, Channel *c)
{
	Process *p = ProcAlloc (my_process, 4096, 1, c);

	*raddr = (int)p;
	return;
}

/* frees memory used by a process -- lets hope it's finished :) */
void real_cift7_free (int addr)
{
	Process *p = (Process *)addr;

	ProcAllocClean (p);
	return;
}

void _cift7_init (int *ws) { real_cift7_init ((int *)(ws[0]), (Channel *)(ws[1])); }
void _cift7_free (int *ws) { real_cift7_free ((int)(ws[0])); }

